
> module Library (takep, splitOn, takeDropWhile, takeDropUntil,
>                 takeUntil, dropUntil) where


> takep :: Int -> [a] -> [a]
> {-# SPECIALIZE takep :: Int -> String -> String #-}
> takep n xs = if n > 0 then take n xs else []

> splitOn :: (Eq a) => a -> [a] -> ([a], [a])
> {-# SPECIALIZE splitOn :: Char -> String -> (String, String) #-}
> splitOn _ [] = ([], [])
> splitOn c (d:ss) = if c == d then ([], ss)
>                              else (d:a, b)
>  where (a, b) = splitOn c ss

> takeDropWhile :: (a -> Bool) -> [a] -> ([a], [a])
> {-# SPECIALIZE takeDropWhile :: (Char -> Bool) -> String
>                                                -> (String, String) #-}
> takeDropWhile _ [] = ([], [])
> takeDropWhile f (x:xs) = if f x then (x:ys, zs) else ([], xs)
>  where (ys, zs) = takeDropWhile f xs

> dropUntil :: (a -> Bool) -> [a] -> [a]
> {-# SPECIALIZE dropUntil :: (Char -> Bool) -> String -> String #-}
> dropUntil _ [] = []
> dropUntil f (x:xs) = if f x then xs else dropUntil f xs

> takeUntil :: (a -> Bool) -> [a] -> [a]
> {-# SPECIALIZE takeUntil :: (Char -> Bool) -> String -> String #-}
> takeUntil _ [] = []
> takeUntil f (x:xs) = if f x then [] else x:takeUntil f xs

> takeDropUntil :: (a -> Bool) -> [a] -> ([a], [a])
> {-# SPECIALIZE takeDropUntil :: (Char -> Bool) -> String
>                                                -> (String, String) #-}
> takeDropUntil _ [] = ([], [])
> takeDropUntil f (x:xs) = if f x then ([], xs) else (x:ys, zs)
>  where (ys, zs) = takeDropUntil f xs

