
> module Type_Data (
>                   {- Colour -}
>                   ColourP,
>                   {- Sort -}
>                   SortOrder(..),
>                   {- Opts -}
>                   Flag(..), MyOptions, Pattern, Mask, Success(..),
>                   {- PrettyPrint -}
>                   PrettyPrintDir(..),
>                   {-  -}
>                   File, FileInfo, FileInfoExt, MaybeError(..)
>                  ) where

> import Posix

Colour

> type ColourP = (String, String)

Sort

> data SortOrder = Asc | Desc deriving Eq

Opts

> data Flag =
>              Long  | OnePerLine | CommaList | PrintAcross
>            {- -l -}   {- -1 -}    {- -m -}     {- -x -}
>           | ShowAll {- -a -}  | ShowMost {- -A -}
>           | ATime {- -u -}    | CTime {- -c -}
>           | Classify {- -F -} | ClassifyMost {- -p -}
>           | Escape {- -b -}   | Raw {- -N -} | QuoteNames {- -Q -}
>           | HumanReadable Integer {- -h -}
>           | NoGroups       {- -G -}
>           | Sort String    {- --sort -}
>           | Colour         {- --color -}
>           | Width Int      {- -w -}
>           | Tabstop Int    {- -T -}
>           | ShowBlockSize  {- -s -}
>           | FilterBackups  {- -B -}
>           | NumericIDs     {- -n -}
>           | ListDirEntries {- -d -}
>           | Reverse        {- -r -}
>           | Recursive      {- -R -}
>           | ShowInodes     {- -i -}
>           | Dereference    {- -L -}
>           | BlockSize Int  {- --block-size -}
>           | FullTime       {- --full-time -}
>           | ShowBasenames  {- used internally -}
>    deriving (Eq, Show)
> type MyOptions = [Flag]
> type Pattern = String
> type Mask = String
> data Success = Success | Error String | ShowUsage | ShowVersion
>  deriving Eq

PrettyPrint

> data PrettyPrintDir = Down | Across

Main

> type File = [String]
> type Ls_filemode = String
> type Uid = Int
> type Gid = Int
> type Size = Int
> type Date = Integer
> type NumLinks = Int
> type Inode = String
> type SizeBlocks = Int
> type SizeBlocksStr = String
> type FileInfo = (Size, Inode, SizeBlocks, Date, FilePath, FileStatus)
> type FileInfoExt = (Ls_filemode, NumLinks, Uid, Gid, Size, Inode,
>                     SizeBlocksStr, Date, FilePath, FileStatus,
>                     Maybe FilePath, Maybe FileStatus)
> data MaybeError a = IsOK a | IsError String

